import { ServiceRepresentation } from '../domain';
import { ProcfileReconciler } from './ProcfileReconciler';
export declare class ServiceRepresentationChainModifier {
    procfileReconciler: ProcfileReconciler;
    representation: ServiceRepresentation;
    constructor(representation: ServiceRepresentation, procfileReconciler: ProcfileReconciler);
    /**
     * Modify service's name
     * @param serviceName
     * @return {ServiceRepresentationChainModifier}
     */
    name(): string;
    name(serviceName: any): ServiceRepresentationChainModifier;
    /**
     * Modify service's category
     * @param processName
     * @return {ServiceRepresentationChainModifier}
     */
    process(): string;
    process(processName: any): ServiceRepresentationChainModifier;
    /**
     * Modify service's config
     * @param configResolver
     * @return {ServiceRepresentationChainModifier}
     */
    config(): any;
    config(configResolver: any): ServiceRepresentationChainModifier;
    /**
     * modify service's dependencies
     * @param servicesName
     * @return {ServiceRepresentationChainModifier}
     */
    dependency(): string[];
    dependency(servicesName: any): ServiceRepresentationChainModifier;
    /**
     * Publish this service upon IPC-Hub
     * @param {boolean} enable
     */
    publish(enable?: boolean): this;
    /**
     * Drop this service like never happened
     */
    drop(): void;
}
